/* File: SRC\EXPIRE.C */

/**************************************************************************
The Internet Extender ver. 1.0 beta is a software based Network Address 
Translating Router designed to allow for multiple machines on a LAN to 
simultaneously connect through a single IP address to the Internet.
Copyright (C) 1999  Jason Sarich, Dr. Dan Lewis, Santa Clara University

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**************************************************************************/

#include "napt.h"

PRIVATE void	Expire_Mapping(MAPPING far *) ;

void Expire(void)
	{
	MtCSetPri(NULL, MTC_LOW) ;
	Visit_Mappings(Expire_Mapping) ;
	}

PRIVATE void Expire_Mapping(MAPPING far *m)
	{
	if (!m || m->status & STATUS_SERVER) return ;
        if (Check_Timeout(m->time_out)) Del_Mapping(m) ;
	}
