#include <stdio.h>
#include <string.h>
#include "..\include\tcp.h"

#define FINGER_PORT 79

tcp_Socket s ;
char buffer[ 513 ];

void finger(char *userid, longword host, char *hoststring)
	{
	int status;
	int len;


	if (!tcp_open( &s, 0, host, FINGER_PORT, NULL )) return ;
	sock_wait_established(&s, sock_delay, NULL, &status) ;

	strcpy(buffer, userid) ;
	strcat(buffer , "\r\n") ;
	sock_puts(&s, buffer) ;

	sock_wait_input(&s, 30, NULL, &status) ;
	len = sock_fastread(&s, buffer, 512) ;
	buffer[len] = '\0' ;
	puts(buffer) ;
	sock_close( &s );

sock_err:
	if (status == -1) puts(sockerr(&s)) ;
	}


main(int argc, char **argv)
	{
	char *user, *server, *p ;
	longword host ;
	int status ;

	if (argc != 2)
		{
		puts("FINGER userid@server") ;
		exit( 3 ) ;
		}

	if (server = strchr(user = argv[1], '@')) *server++ = '\0' ;
	else server = argv[1], user = "" ;

	sock_init();
	if (!(host = resolve(server)))
		{
		strcpy(buffer, "Could not resolve host ") ;
		strcat(buffer, server) ;
		puts(buffer) ;
		exit(3) ;
		}

	exit(finger(user, host, server)) ;
	}
