;
;
;  Usage :
;           void far *inchksum()
;
;  Internet compatible 1's complement checksum
;
;  (c) 1990 University of Waterloo,
;           Faculty of Engineering,
;           Engineering Microcomputer Network Development Office
;
;  version
;
;    0.1    17 Dec -1990   E. P. Engelke
;
;
	org	$
	idt	inchksum

	ldef	inchksum
inchksum:
	push	bp
	mov	bp,sp

        ; Compute 1's-complement sum of data buffer
        ;
        ; unsigned lcsum( unsigned (far) *buf, unsigned cnt)
	IFDEF	USENEAR
        mov     SI, [BP+6]
	mov     CX, [BP+8]       ; cx = cnt
	ELSE
	push	DS
        lds     SI, [BP+6]
	mov     CX, [BP+10]       ; cx = cnt
	ENDIF

        mov     BL, CL

	shr     CX, 1			; group into words
	xor	DX, DX			; set checksum to 0
        cld

        jcxz    remain
        clc
deloop: lodsw
	adc	DX, AX
	loop	deloop

        adc     DX, 0                   ; only two necessary
        adc     DX, 0

remain: and     BL, 1
        jz      done

        xor     AH, AH
        lodsb
        add     DX, AX
        adc     DX, 0
        adc     DX, 0

done:   mov	AX,DX		; result into ax
        or      AX,AX
ok:
	IFNDEF	USENEAR
	pop     DS
	ENDIF
	pop	bp
	retfar

        end
