/*
 * debugging messages... can be used inside interrupts
 *
 */

static int far *screenptr = 0xB8000000L;

#ifdef	__POWERC
#define	VOID	void
#else
#define	VOID
#endif

VOID dputch( x )
char x;
{
#ifdef	__POWERC
    if (x == '\n') screenptr = (int far *) 0xb8000000L;
#else
    if (x == '\n') screenptr = 0xb8000000L;
#endif
    else *(screenptr++) = (x&0xff) | 0x700;
}

VOID dmsg( s )
char *s;
{
    dputch('\r');
    dputch('\n');
    while ( *s )
	dputch( *s++ );
}

VOID dhex1int( x )
int x;
{
    x &= 0x0f;
    if ( x > 9 ) x = 'A' + x - 0xa;
    else x += '0';
    dputch( x );
}

VOID dhex2int( x )
int x;
{
    dhex1int( x>>4 );
    dhex1int( x );
    dputch(' ');
}

VOID dhex4int( x )
int x;
{
    dhex2int( x >> 8 );
    dhex2int( x );
}
