/* File: MODEL.H */

#ifndef	MEMORY_MODEL
#define	MEMORY_MODEL

#ifdef	USENEAR

#define	FAR
#define	_MEMCPY(a, b, c)	memcpy(a, b, c)
#define	_MEMSET(a, b, c)	memset(a, b, c)
#define	_MALLOC(a) 		malloc(a)
#define	_FREE(a) 		free(a)
#define	_MEMCHR(a, b, c) 	memchr(a, b, c)

#else

#define	FAR	far
#define	_MEMCPY(a, b, c) farmemcpy((byte far *) (a), (byte far *) (b), c)
#define	_MEMSET(a, b, c)	farmemset(a, b, c)
#define	_MALLOC(a) 		farmalloc((unsigned long) (a))
#define	_FREE(a) 		farfree(a)
#define	_MEMCHR(a, b, c) 	farmemchr(a, b, c)

#endif

#endif
