#include <copyright.h>
#include <wattcp.h>

sock_debugdump( udp_Socket *u )
{
    tcp_Socket *t;

    t = (tcp_Socket *)u;

    printf("next	%4x\n", u->next);
    printf("type    %4x\n", u->ip_type);
    printf("error %s\n", u->err_msg ? u->err_msg : "(NONE)");
    printf("timervalue %8lx returns %sexpired\n",
	u->usertimer, chk_timeout(u->usertimer)?"":"NOT ");
    printf("udp rdata %u (%Fs)\n", u->rdatalen, u->rdata );
    printf("tcp rdata %u (%Fs)\n", t->rdatalen, t->rdata );
    printf("tcp state %u\n", t->state );
}
