/* File: INC\GLOBALS.H */

/**************************************************************************
The Internet Extender ver. 1.0 beta is a software based Network Address 
Translating Router designed to allow for multiple machines on a LAN to 
simultaneously connect through a single IP address to the Internet.
Copyright (C) 1999  Jason Sarich, Dr. Dan Lewis, Santa Clara University

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**************************************************************************/

#ifdef	NAPT

char err1[] = "Can't map %s packet" ;
char err2[] = "Can't send local Ethernet packet" ;
char err3[] = "Bad protocol checksum on %s packet" ;
char err4[] = "Unknown protocol (%u) on %s packet" ;
char err5[] = "Truncated %s packet" ;
char err6[] = "Bad IP version number (%d) on %s packet" ;

char			inbound[]	= "inbound" ;
char			outbound[]	= "outbound" ;
char			remote_name[64]	= "" ;

unsigned		remote_pdi	= 0 ;
unsigned		local_pdi	= 0 ;

longword		remote_IP	= 0L ;	/* Intel byte order */
longword		remote_mask	= 0L ;
longword		remote_gateway	= 0L ;
longword		local_IP	= 0L ;
longword		local_mask	= 0L ;
longword		local_gateway	= 0L ;

longword		_remote_IP	= 0L ;	/* Network byte order */
longword		_remote_mask	= 0L ;
longword		_remote_gateway	= 0L ;
longword		_local_IP	= 0L ;
longword		_local_mask	= 0L ;
longword		_local_gateway	= 0L ;

#else

extern char		err1[], err2[], err3[], err4[], err5[], err6[] ;
extern char		inbound[], outbound[], remote_name[64] ;
extern unsigned		remote_pdi, local_pdi ;
extern longword		remote_IP, _remote_IP ;
extern longword		remote_mask, _remote_mask ;
extern longword		remote_gateway, _remote_gateway ;
extern longword		local_IP, _local_IP ;
extern longword		local_mask, _local_mask ;
extern longword		local_gateway, _local_gateway ;

#endif

